clear all
close all
affiche=1
fe=12000;
r=read_complex_binary('rds_rrc_mm_12k.bin');  % Rire & Chanson

p=angle(r);
p=p-mean(p);

s=(p>0);s=s-mean(s); % binary slicer
s1=s(2:2:end-1);
s2=s(3:2:end);
s1=(s1>0); s2=(s2>0);
so=mod(s1+s2,2)';
% https://www.mathworks.com/examples/simulink-communications/mw/rtlsdrradio_product-RBDSSimulinkExample-rbds-rds-and-radiotext-plus-rt-fm-receiver

%%%%%%%% fin layer 1 %%%%%%%%%%%%%%
% p.75 US, 64 EU
A=  [0 0 1 1 1 1 1 1 0 0]; % A  
sA2=[1 1 1 1 0 1 1 0 0 0];
B=  [0 1 1 0 0 1 1 0 0 0]; % B
sB2=[1 1 1 1 0 1 0 1 0 0]; % sB
C=  [0 1 0 1 1 0 1 0 0 0];
sC2=[1 0 0 1 0 1 1 1 0 0];
Cp= [1 1 0 1 0 1 0 0 0 0];
% sCp=[1 0 1 1 1 0 1 1 0 0];
sCp=[1 1 1 1 0 0 1 1 0 0]; % an495
D=  [0 1 1 0 1 1 0 1 0 0];
sD2=[1 0 0 1 0 1 1 0 0 0]; % incoherent avec an495
% sD2=[0 1 0 1 0 1 1 0 0 0]; % an495

% p.74
m=[
 1 0 0 0 0 0 0 0 0 0 ;
 0 1 0 0 0 0 0 0 0 0 ;
 0 0 1 0 0 0 0 0 0 0 ;
 0 0 0 1 0 0 0 0 0 0 ;
 0 0 0 0 1 0 0 0 0 0 ;
 0 0 0 0 0 1 0 0 0 0 ;
 0 0 0 0 0 0 1 0 0 0 ;
 0 0 0 0 0 0 0 1 0 0 ;
 0 0 0 0 0 0 0 0 1 0 ;
 0 0 0 0 0 0 0 0 0 1 ;
 1 0 1 1 0 1 1 1 0 0 ;
 0 1 0 1 1 0 1 1 1 0 ;
 0 0 1 0 1 1 0 1 1 1 ;
 1 0 1 0 0 0 0 1 1 1 ;
 1 1 1 0 0 1 1 1 1 1 ;
 1 1 0 0 0 1 0 0 1 1 ;
 1 1 0 1 0 1 0 1 0 1 ;
 1 1 0 1 1 1 0 1 1 0 ;
 0 1 1 0 1 1 1 0 1 1 ;
 1 0 0 0 0 0 0 0 0 1 ;
 1 1 1 1 0 1 1 1 0 0 ;
 0 1 1 1 1 0 1 1 1 0 ;
 0 0 1 1 1 1 0 1 1 1 ;
 1 0 1 0 1 0 0 1 1 1 ;
 1 1 1 0 0 0 1 1 1 1 ;
 1 1 0 0 0 1 1 0 1 1 ;
];


puissances=2.^[7:-1:0]'; % 128 64 32 6 8 4 2 1
errc=0; errt=0;
texte="";
station="";
debut=0
so=(1-so);
for k=1:length(so)-104
  data1=(so(k:k+25));           % A
  data2=(so(k+26*1:k+25+26*1)); % B
  data3=(so(k+26*2:k+25+26*2)); % C(')
  data4=(so(k+26*3:k+25+26*3)); % D
  mI1=mod(data1*m,2);
  mI2=mod(data2*m,2);
  mI3=mod(data3*m,2);
  mI4=mod(data4*m,2);
  pa=findstr((sA2),(mI1));
  pb=findstr((sB2),(mI2));
  pc=findstr((sC2),(mI3));
  pcp=findstr((sCp),(mI3));
  pd=findstr((sD2),(mI4));
  if (!isempty(pa) && !isempty(pb) && !isempty(pd)) 
     % pty=data2(7)*16+data2(8)*8+data2(9)*4+data2(10)*2+data2(11) % 
     if ((data2(1:4)*puissances(end-3:end))==2)  % text RDS
       texte=[texte char(data4(1:8)*puissances)]
       texte=[texte char(data4(9:16)*puissances)]
     end
     if (sum(data2(1:4))==0)  % text RDS
       station=[station char(data4(1:8)*puissances)];
       station=[station char(data4(9:16)*puissances)]
     end
     if ((data2(1:5)*puissances(end-4:end))==2)  % 1A
%     if ((data2(1)==0) && (data2(2)==0) && (data2(3)==0) && (data2(4)==1) && data2(4)==0) % 1A
        day=data4(1:5)*puissances(end-4:end);
        heure=data4(6:10)*puissances(end-4:end);
        minute=data4(11:16)*puissances(end-5:end); 
        printf("temps %d %d %d\n",day,heure,minute);
     end
  else % printf(".");
  end
  
  if (!isempty(pa) && isempty(pb) && !isempty(pd))   % cas d'une erreur sur block B
     printf("erreur B : ");
     [tmp,ligne]=ismember(abs(mI2-sB2),m,'rows');
     if (tmp>0) 
       data2(ligne)=1-data2(ligne);                  % corrige le bit errone'
       if ((data2(1:4)*puissances(end-3:end))==2)  % text RDS
          texte=[texte char(data4(1:8)*puissances)]
          texte=[texte char(data4(9:16)*puissances)]
          errc=errc+1;
       end
       if (sum(data2(1:4))==0)  % text RDS
         station=[station char(data4(1:8)*puissances)];
         station=[station char(data4(9:16)*puissances)]
         errt=errt+1;
       end
       if ((data2(1:5)*puissances(end-4:end))==2)  % 1A
          day=data4(1:5)*puissances(end-4:end);
          heure=data4(6:10)*puissances(end-4:end);
          minute=data4(11:16)*puissances(end-5:end); 
          printf("temps %d %d %d\n",day,heure,minute);
       end
     end
  end
end
printf("\n");
length(station)
errt
length(texte)
errc

%p.66 du standard
%C.1.1 Acquisition of group and block synchronisation
%         To acquire group and block synchronisation at the receiver (for example 
% when the receiver is first switched on, on tuning to a new station, or after a 
% prolonged signal-fade) the syndrome Ã¡ must be calculated for each received 26-bit
% sequence. That is, on every data-clock pulse the syndrome of the currently stored 
% 26-bit sequence (with the most recently received data bit at one end and the bit 
% received 26 clock pulses ago at the other) is calculated on every clock pulse.  
%         This bit-by-bit check is done continuously until two syndromes corresponding 
% to valid offset words, and in a valid sequence for a group i.e.[ A, B, C (or C'), D] 
% are found n x 26 bits apart (where n = 1, 2, 3, etc.). When this is achieved,
% the decoder is synchronised and the offset words which are added to the parity bits at 
% the transmitter are subtracted at the receiver before the syndrome calculation for error 
% correction/ detection is done (see annex B).

% http://www.anotherurl.com/library/sdr/sdrrds.htm
% https://rftap.github.io/blog/2016/08/27/decoding-rds-with-rftap.html
% http://davidswiston.blogspot.fr/2014/12/pyfmradio-radio-broadcast-data-system.html
% specs : http://www.interactive-radio-system.com/docs/EN50067_RDS_Standard.pdf
